#ifndef FILETRANSFER_H
#define FILETRANSFER_H

#ifndef SERVER_H
#include "server.h"
#endif

typedef struct {
  char HTXF[4];
  guint32 xferid;
  guint32 uplen;
  guint32 pad;
} FTHandshake;

#define FTHandshake_sizeof 16

typedef struct {
  char name[4];
  guint32 pad[2];
  guint32 size;
} FTHeader;

#define FTHeader_sizeof 16

typedef struct {
  char FILP[4];
  guint16 version;
  guint16 pad1;
  guint32 pad2[3];
  guint32 count;
} FTInit;

#define FTInit_sizeof 24

typedef struct {
  char amac[4],type[4],creator[4];
} FTInfo;

#define FTInfo_sizeof (17*4)

void filetransfer_start(FileData *fd,int is_upload,FileEntry *which_file);
void handle_ftq_update(Connection *c,HLTransaction *t,gpointer data);


#endif
