#ifndef SERVER_H
#define SERVER_H

#ifndef GNOME_H
#include <gnome.h>
#endif
#ifndef TASKS_H
#include "tasks.h"
#endif
#ifndef BOOKMARKS_H
#include "bookmarks.h"
#endif
#ifndef THREADS_H
#include "threads.h"
#endif

typedef struct {
  GnomeUIInfo *toolbar_info;
  GtkWidget *main_window;
  GtkWidget *notebook;
  GtkWidget *hbox;
} ConnectionGui;

typedef struct _connection {
  Bookmark *bookmark;
  FILE *infd,*outfd;
  Task *task;
  int end_count;
  int version;
  Thread thread_in,thread_out;
  GCond *signal;
  GMutex *mutex;
  gboolean can_read;
  GList *proclist;
  GList *replies_pending;
  GList *hooks;
  ConnectionGui *gui;
} Connection;

extern GList *connections_list;

void hooks_create(Connection *c,char *name,
		void (*create)(Connection *),
		void (*destroy)(Connection *,gpointer));
void hooks_set_data(Connection *c,char *name,gpointer data);
gpointer hooks_get_data(Connection *c,char *name);

void server_connect_to(Bookmark *b);
void server_transaction_start(Connection *c,
			      void (*start)(Connection *c,gpointer p),
			      gpointer data);
void server_cancel(Connection *c);

void forall_servers(void (*func)(Connection *,gpointer),gpointer);

#endif
