#ifndef TASKS_H
#define TASKS_H

#include <gtk/gtk.h>

struct _Task;

typedef void (*TaskCancel)(struct _Task *);

typedef struct {
  int current_bytes,session_bytes,total_bytes;
  GTimer *timer;
  double last_transfer;
  char *text;
} FileTransferTask;

typedef struct _Task {
  struct _Task *next;
  
  gfloat percdone;
  gboolean is_download;
  gboolean is_running;

  TaskCancel user_cancel;
  gpointer user_data;

  int list_pos;
  int is_changed;
  GtkWidget *widget;
  GtkWidget *label;
  GtkWidget *description;
  GtkWidget *progressbar;
  char text[2048];
  FileTransferTask *ftt;
} Task;

#define TASK_CHANGED_POS 1
#define TASK_CHANGED_TEXT 2

Task *task_new(const gchar *description);
void task_add(Task *t);
void task_update(Task *t,gboolean new_text,gfloat pos);
void task_remove(Task *t);
void task_remove_when_idle(Task *t);
void remove_all_tasks(void);
void task_set_filetransfer(Task *,FileTransferTask *);

GtkWidget *new_task_widget(void);


#endif
